# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify Alma, CentOS, CentOS Stream and Rocky Linux as rhel
%if "%{__distinit}" == "a" || "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "cs" || "%{__distinit}" == "rl"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

Name:		perl-XML-LibXSLT
Version:	2.003000
Release:	1.%{__distinit}%{__distvers}
Summary:	Perl module for interfacing to GNOME's libxslt
# lib/XML/LibXSLT.pm: GPL-1.0-or-later OR Artistic-1.0-Perl
# lib/XML/LibXSLT/Quick.pm: MIT
License:	(GPL-1.0-or-later OR Artistic-1.0-Perl) AND MIT
URL:		https://metacpan.org/release/XML-LibXSLT
Source0:	https://cpan.metacpan.org/modules/by-module/XML/XML-LibXSLT-%{version}.tar.gz
# Module Build
# Note: libxslt versions 1.1.25 and 1.1.27 won't work; 1.1.28 or later is recommended
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	gcc
BuildRequires:	libxslt-devel >= 1.1.18
BuildRequires:	make
BuildRequires:	perl-devel
BuildRequires:	perl-generators
BuildRequires:	perl-interpreter
BuildRequires:	perl(:VERSION) >= 5.14.0
BuildRequires:	perl(Config)
BuildRequires:	perl(Cwd)
BuildRequires:	perl(ExtUtils::MakeMaker)
BuildRequires:	perl(File::Path) >= 2.06
BuildRequires:	perl(File::Spec)
BuildRequires:	perl(Test)
# Module Runtime
BuildRequires:	perl(autodie)
BuildRequires:	perl(Carp)
BuildRequires:	perl(DynaLoader)
BuildRequires:	perl(Exporter)
BuildRequires:	perl(strict)
BuildRequires:	perl(vars)
BuildRequires:	perl(warnings)
BuildRequires:	perl(XML::LibXML) >= 1.70
# Test Suite
BuildRequires:	perl(Data::Dumper)
BuildRequires:	perl(Devel::Peek)
BuildRequires:	perl(Encode)
BuildRequires:	perl(IO::Socket::INET)
BuildRequires:	perl(Test::More)
# Optional Tests
BuildRequires:	perl(Test::CPAN::Changes) >= 0.27
BuildRequires:	perl(Test::Pod) >= 1.14
BuildRequires:	perl(Test::TrailingSpace)
# Dependencies
%if 0%{?fedora} < 38 && 0%{?rhel} < 10
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
%endif

# Don't "provide" private Perl lib
# Also fix doc-file provides and requires
%global __provides_exclude ^(LibXSLT\\.so|perl\\(Driver::)
%global __requires_exclude ^perl\\((Cwd|Driver::|IO::File|XML::Sablotron)

%description
This module is a fast XSLT library, based on the Gnome libxslt engine
that you can find at http://www.xmlsoft.org/XSLT/

%prep
%setup -q -n XML-LibXSLT-%{version}

%build
perl Makefile.PL INSTALLDIRS=vendor OPTIMIZE="%{optflags}"
make %{?_smp_mflags}

%install
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
find %{buildroot} -type f -name '*.bs' -empty -delete
%{_fixperms} -c %{buildroot}

%check
make test

%files
%license LICENSE
%doc Changes README benchmark/ example/
%{perl_vendorarch}/auto/XML/
%{perl_vendorarch}/XML/
%{_mandir}/man3/XML::LibXSLT.3*
%{_mandir}/man3/XML::LibXSLT::Quick.3*

%changelog
* Sat Jun 15 2024 Paul Howarth <paul@city-fan.org> - 2.003000-1
- Update to 2.003000
  - lib/XML/LibXSLT/Quick.pm:
    - Add an 'implicit' type to $dest
    - Correct a type spelling ('file' instead of 'path')

* Fri Jun 14 2024 Paul Howarth <paul@city-fan.org> - 2.002001-6
- Perl 5.40 rebuild

* Fri Jul 14 2023 Paul Howarth <paul@city-fan.org> - 2.002001-2
- Perl 5.38 rebuild

* Fri Feb 10 2023 Paul Howarth <paul@city-fan.org> - 2.002001-1
- Update to 2.002001
  - Corrections and refactorings in Makefile.PL
- Use author-independent source URL
- Use SPDX-format license tag

* Thu Jun  2 2022 Paul Howarth <paul@city-fan.org> - 2.002000-2
- Perl 5.36 rebuild

* Tue May 17 2022 Paul Howarth <paul@city-fan.org> - 2.002000-1
- Update to 2.002000
  - XML::LibXSLT::Quick.pm:
    - Clarify license (GH#5)
    - Add docs and a $source 'string' type
  - Makefile.PL:
    - Clean-ups
    - Require perl-5.14.0 at a minimum
      (https://github.com/shlomif/supporting-older-perl5-releases)

* Mon May 16 2022 Paul Howarth <paul@city-fan.org> - 2.001000-1
- Update to 2.001000
  - XML::LibXSLT::Quick.pm: add 'params' support for generic_transform()
- License changed to (GPL+ or Artistic) and MIT

* Sun Apr 10 2022 Paul Howarth <paul@city-fan.org> - 2.000000-1
- Update to 2.000000
  - Add lib/XML/LibXSLT/Quick.pm
  - Clean-ups

* Mon May 24 2021 Paul Howarth <paul@city-fan.org> - 1.99-6
- Perl 5.34 rebuild

* Mon Jun 29 2020 Paul Howarth <paul@city-fan.org> - 1.99-3
- Perl 5.32 rebuild

* Fri Jan 17 2020 Paul Howarth <paul@city-fan.org> - 1.99-1
- Update to 1.99
  - Remove checks for libxslt versions (CPAN RT#131155)

* Thu Jan 16 2020 Paul Howarth <paul@city-fan.org> - 1.98-1
- Update to 1.98
  - Replace xslt-config with pkg-config (GH#3); the former is going away

* Tue Jan 14 2020 Paul Howarth <paul@city-fan.org> - 1.97-1
- Update to 1.97
  - Fix test failures with XML::LibXML v2.0202 (CPAN RT#131457)

* Sun Jun  9 2019 Paul Howarth <paul@city-fan.org> - 1.96-5
- Perl 5.30 rebuild

* Fri Jun 29 2018 Paul Howarth <paul@city-fan.org> - 1.96-2
- Perl 5.28 rebuild

* Wed Feb 21 2018 Paul Howarth <paul@city-fan.org> - 1.96-1
- Update to 1.96
  - $Config{libs} is not needed (CPAN RT#83028)
  - Move to git/GitHub: - https://github.com/shlomif/perl-XML-LibXSLT
    - For Travis-CI/etc.

* Wed Aug 23 2017 Paul Howarth <paul@city-fan.org> - 1.95-7
- Do not break tests by updating libxml2 library (CPAN RT#86398)
- Do not link against perl extension libraries (#905482, #1481324,
  CPAN RT#83028)
- BR: perl-generators unconditionally
- BR: perl-interpreter rather than perl

* Thu Jun 15 2017 Paul Howarth <paul@city-fan.org> - 1.95-4
- Drop support for EOL distributions prior to F-13
  - Drop BuildRoot: and Group: tags
  - Drop explicit buildroot cleaning in %%install section
  - Drop explicit %%clean section
  - BR: perl-devel unconditionally

* Sat Jul 30 2016 Paul Howarth <paul@city-fan.org> - 1.95-1
- Update to 1.95
  - Makefile.PL shouldn't run "pkg-config libexslt" if LIBS or INC were
    provided (CPAN RT#116461)
- Update linking patch

* Tue Jul 26 2016 Paul Howarth <paul@city-fan.org> - 1.94-7
- Fix FTBFS when perl is not in the minimal buildroot

* Fri May 27 2016 Paul Howarth <paul@city-fan.org> - 1.94-6
- Rebuild for libxslt 1.1.29
- BR: perl-devel and perl-generators where available
- Package LICENSE file
- Simplify find commands using -empty and -delete
- Prefer %%global over %%define

* Mon Jan 26 2015 Paul Howarth <paul@city-fan.org> - 1.94-1
- Update to 1.94
  - Add the ->max_vars function to set the MaxVars (CPAN RT#101413)
  - Fix breakage caused by the MaxVars change on older versions of libxslt
    (CPAN RT#101605)

* Fri Jan  9 2015 Paul Howarth <paul@city-fan.org> - 1.92-5
- Do not link against perl extension libraries (CPAN RT#83028)
- Classify buildreqs by usage

* Fri Sep 12 2014 Paul Howarth <paul@city-fan.org> - 1.92-4
- Perl 5.20 rebuild

* Sat Apr 12 2014 Paul Howarth <paul@city-fan.org> - 1.92-1
- Update to 1.92
  - t/cpan-changes.t: minimum version of Test::CPAN::Changes; this is to
    avoid test failures such as:
    http://www.cpantesters.org/cpan/report/5af7d5eb-6bfa-1014-b84e-eb85912f2992

* Fri Apr 11 2014 Paul Howarth <paul@city-fan.org> - 1.90-2
- BR: perl(Test::TrailingSpace)

* Thu Apr 10 2014 Paul Howarth <paul@city-fan.org> - 1.90-1
- Update to 1.90
  - Handle $Config{dlext} correctly on Windows (CPAN RT#94516)
  - Fix some POD problems and add t/pod.t
  - Add t/cpan-changes.t and convert Changes to CPAN::Changes format
  - Remove trailing whitespace and add t/style-trailing-space.t
- Add buildreqs for new tests
- Drop %%defattr, redundant since rpm 4.4

* Thu Mar  6 2014 Paul Howarth <paul@city-fan.org> - 1.89-1
- Update to 1.89
  - Fix memory management of node-sets returned from extension functions;
    without calling xsltExtensionInstructionResultRegister, node-sets could be
    freed too early, leading to strange errors or segfaults
    (Gnome Bug #562302, CPAN RT#93349)
  - Document input_callbacks methods
  - Don't register libxml2 input callbacks twice (CPAN RT#60313)
  - Fix memory leak with extension functions returning node lists
    (CPAN RT#55623, CPAN RT#76596)

* Mon Feb 17 2014 Paul Howarth <paul@city-fan.org> - 1.88-1
- update to 1.88
  - fix t/xml-grammar-failures.t based on the xml:space commentary here at
    https://mail.gnome.org/archives/xml/2014-February/msg00000.html; it
    caused some failures that were ultimately our fault

* Mon Feb  3 2014 Paul Howarth <paul@city-fan.org> - 1.87-1
- update to 1.87
  - decrease the minimum libxslt version again; setting it as 1.1.28 did not
    fix the failures, and now we have some more tests to test against it
    (CPAN RT#92659)

* Sun Feb  2 2014 Paul Howarth <paul@city-fan.org> - 1.86-1
- update to 1.86
  - add t/xml-grammar-failures.t to catch test failures in dependent modules

* Sat Feb  1 2014 Paul Howarth <paul@city-fan.org> - 1.85-1
- update to 1.85
  - add "use strict;" and "use warnings;" globally
  - add LICENSE to the MANIFEST

* Fri Dec 27 2013 Paul Howarth <paul@city-fan.org> - 1.84-1
- update to 1.84
  - hopefully fix a segmentation fault on Win32 introduced in the last version
    (CPAN RT#91652)

* Mon Dec 23 2013 Paul Howarth <paul@city-fan.org> - 1.83-1
- update to 1.83
  - get rid of compiler warnings when compiling using CLANG (CPAN RT#91118)

* Wed Nov  6 2013 Paul Howarth <paul@city-fan.org> - 1.82-1
- update to 1.82
  - Makefile.PL: report LibXSLT mismatch correctly (CPAN RT#90085)

* Sat Jul 20 2013 Paul Howarth <paul@city-fan.org> - 1.81-2
- Perl 5.18 rebuild

* Fri Jul  5 2013 Paul Howarth <paul@city-fan.org> - 1.81-1
- update to 1.81 (typo fix)

* Wed Jan 23 2013 Paul Howarth <paul@city-fan.org> - 1.80-1
- update to 1.80
  - bump the minimum version of libxslt2 to 1.1.28, due to failures such as
    http://www.cpantesters.org/cpan/report/6f5029ee-639a-11e2-8465-2a97270fb964

* Mon Nov 26 2012 Paul Howarth <paul@city-fan.org> - 1.79-1
- update to 1.79
  - die when libxslt is 1.1.27 (due to http://bugzilla.gnome.org/684564)

* Thu Nov 22 2012 Paul Howarth <paul@city-fan.org> - 1.78-3
- rebuild for libxslt 1.1.28
- fix bogus dates in spec changelog

* Wed Sep 12 2012 Paul Howarth <paul@city-fan.org> - 1.78-2
- rebuild for libxslt 1.1.27

* Thu Sep  6 2012 Paul Howarth <paul@city-fan.org> - 1.78-1
- update to 1.78
  - add output_method method
  - update documentation of media_type

* Sat Jun 30 2012 Paul Howarth <paul@city-fan.org> - 1.77-2
- BR: perl(Cwd), perl(Data::Dumper), perl(Devel::Peek), perl(File::Spec),
  perl(IO::Socket::INET) and perl(Test)
- add runtime dependency on perl(Exporter)
- drop buildreq perl(DynaLoader) as it's not dual-lived
- drop support for old distributions prior to FC-3:
  - don't need to define %%{perl_vendorarch}
  - use DESTDIR rather than PERL_INSTALL_ROOT
  - use %%{_fixperms} macro rather than our own chmod incantation

* Sun Feb 26 2012 Paul Howarth <paul@city-fan.org> - 1.77-1
- update to 1.77
  - clarify the quoting of string parameters to the XSLT transformation
- BR: perl(Encode)
- no need to remove empty directories from buildroot

* Fri Jan 13 2012 Paul Howarth <paul@city-fan.org> - 1.76-1
- update to 1.76
  - made LibXSLT.xs compile with C compilers that don't accept declarations
    inside blocks (CPAN RT#73905)
- BR: perl(DynaLoader) and perl(Exporter)

* Fri Oct 28 2011 Paul Howarth <paul@city-fan.org> - 1.75-1
- update to 1.75
  - convert t/03input.t from Test.pm to Test::More
  - fix for segfault in free() (CPAN RT#71345)

* Wed Oct 26 2011 Paul Howarth <paul@city-fan.org> - 1.74-1
- update to 1.74
  - convert the following test scripts from Test.pm to Test::More:
    - t/01basic.t
    - t/02dromeds.t
    - t/04params.t
    - t/05quick.t
    - t/06output.t
    - t/06entities.t
    - t/07blankdoc.t
    - t/08literal.t
    - t/09exslt.t
    - t/10functions.t
    - t/11utf8.t
    - t/12import.t
    - t/13error.t
    - t/14security.t
    - t/15misc.t
  - in the process, made "Encode" and perl ≥ 5.8.1 pre-requisites of this
    distribution
  - add the "make runtest" and "make distruntest" targets to test using
    Test-Run
- BR: perl ≥ 5.8.1 and perl(Test::More)

* Sun Oct  9 2011 Paul Howarth <paul@city-fan.org> - 1.73-1
- update to 1.73
  - possible fix for CPAN RT#71456: made the port reservation on t/14security.t
    for the non-existent URL more robust
- BR: perl(Carp)

* Thu Oct  6 2011 Paul Howarth <paul@city-fan.org> - 1.72-1
- update to 1.72
  - moved the benchmarking code under benchmark/ so it won't be indexed by CPAN
  - avoid leaking memory inside extension elements by cleaning up on stylesheet
    DESTROY
  - xsltInit() and xsltCleanupGlobals() to avoid leaking memory on
    init/shutdown
  - added support for stylesheet context functions via a
    $stylesheet->register_function() method with the same arguments as 
    XML::LibXSLT->register_function()
  - added support for register_element() on stylesheet objects; the callback
    may leak memory though - nothing frees the _private attributes of the
    node + document owner for the passed arguments?
- add benchmark/ directory as %%doc and add filters for doc-file-dependencies

* Sun Sep 11 2011 Paul Howarth <paul@city-fan.org> - 1.71-1
- update to 1.71
  - blacklist libxslt-1.1.25, which has a deadlock that hangs a test
    (CPAN RT#50487)
  - fix unexpected webserver dependency in test (CPAN RT#52422)
  - update the version control instructions in the README to point to
    bitbucket.org
- this release by SHLOMIF -> update source URL

* Fri Jul  8 2011 Paul Howarth <paul@city-fan.org> - 1.70-6
- rebuild for perl 5.14.1 in Rawhide
- nobody else likes macros for commands
- fix dist tag for CentOS 6 and Scientific Linux

* Thu Jun 24 2010 Paul Howarth <paul@city-fan.org> - 1.70-5
- rebuild for perl 5.12.1 in Rawhide

* Thu May 27 2010 Paul Howarth <paul@city-fan.org> - 1.70-4
- fix dist tag for RHEL-6 Beta

* Thu Mar 11 2010 Paul Howarth <paul@city-fan.org> - 1.70-3
- rebuild for new libgdbm in Rawhide

* Thu Feb 25 2010 Paul Howarth <paul@city-fan.org> - 1.70-2
- dist tag for Rawhide no longer needs special-casing

* Fri Oct  9 2009 Paul Howarth <paul@city-fan.org> - 1.70-1
- import from Fedora
- update to 1.70
  - fixed various bugs
  - documentation updates
  - sync with latest XML::LibXML ABI and add a compatibility check
  - do not force -lgcrypt and -lgpg-error linker flags
  - fix for attribute nodes returned by user-defined XPath functions
  - address #41542: restore internalDTD subset on the source document of a
  | transformation (libxslt unlinks it)
- drop upstreamed refcount patch
- filter provides for perl shared objects using %%{?perl_default_filter}

* Sun Jul 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.68-4
- rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Wed Mar 18 2009 Stepan Kasal <skasal@redhat.com> - 1.68-3
- patch to fix a refcounting bug leading to segfaults (#490781)

* Thu Feb 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.68-2
- rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Sat Dec 20 2008 Paul Howarth <paul@city-fan.org> - 1.68-1
- update to 1.68
- relax hard version requirement on XML::LibXML, which is at 1.69 upstream
  but 1.67 or above will suffice (care will still have to be taken to keep
  the packages in sync, particularly when XML::LibXML is updated)
- specify $RPM_OPT_FLAGS once rather than twice
- drop historical perl version requirement, which is met even by EL-3
- explicitly buildreq ExtUtils::MakeMaker rather than just perl-devel

* Mon Nov  3 2008 Stepan Kasal <skasal@redhat.com> - 1.66-2
- require XML::LibXML of the same version

* Fri Aug  8 2008 Zing <zing@fastmail.fm> - 1.66-1
- update to 1.66

* Sat May 31 2008 Zing <zing@fastmail.fm> - 1.63-6
- rpm check stage barfs on || :

* Mon Mar  3 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 1.63-5
- rebuild for new perl (again)

* Tue Feb 19 2008 Fedora Release Engineering <rel-eng@fedoraproject.org> - 1.63-4
- Autorebuild for GCC 4.3

* Fri Feb  8 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 1.63-3
- rebuild for new perl

* Sat Jan 19 2008 Zing <zing@fastmail.fm> - 1.63-2
- build requires gdbm-devel

* Fri Jan 18 2008 Zing <zing@fastmail.fm> - 1.63-1
- update to 1.63

* Sat Aug 11 2007 Zing <zing@fastmail.fm> - 1.62-2
- require perl-devel

* Tue Aug  7 2007 Zing <zing@fastmail.fm> - 1.62-1
- update to 1.62
- Conform to Fedora Licensing Guideline

* Fri Sep  8 2006 Zing <zing@fastmail.fm> - 1.58-3
- rebuild for FE6

* Tue Feb 14 2006 Zing <shishz@hotpop.com> - 1.58-2
- rebuild for FE5

* Wed Aug 17 2005 Zing <shishz@hotpop.com> - 1.58-1
- new upstream
- use dist macro

* Thu Apr  7 2005 Michael Schwendt <mschwendt[AT]users.sf.net>
- rebuilt

* Sat Mar  5 2005 Ville Skyttä <ville.skytta at iki.fi> - 1.57-3
- Drop pre-FC2 LD_RUN_PATH hack.
- Install benchmark.pl only as %%doc.

* Sat Feb 26 2005 Zing <shishz@hotpop.com> - 1.57-2
- QA from Ville Skyttä
-	BuildRequires XML::LibXML >= 1.57
-	BuildRequires libxslt-devel
-	put benchmark.pl in %%doc

* Fri Feb 25 2005 Zing <shishz@hotpop.com> - 1.57-1
- First build.

